;lcd-routines.asm by fgl for HD44780 compilant LCD-Screens

.equ LCD_PORT = PORTD
.equ LCD_CTRL_PORT = PORTB
.equ PIN_EN = 0
.equ PIN_RS = 1
.equ XTAL = 4000000



;LCD enablen
lcd_enable:	sbi LCD_CTRL_PORT, PIN_EN    ; Enable high
           	nop                          ; 3 Taktzyklen warten
           	nop
           	nop
           	cbi LCD_CTRL_PORT, PIN_EN    ; Enable wieder low
           	ret                          ; Und wieder zurck


;kurze Pause
delay50us: 	push r16                     ; 50us Pause
			ldi  r16, ( XTAL * 50 / 3 ) / 1000000
delay50us_:
           	dec  r16
           	brne delay50us_
			pop  r16
           	ret                          ; wieder zurck
 
;Lngere Pause fr manche Befehle
delay5ms:	push r16                     ; 5ms Pause
			push r17
           	ldi  r16, ( XTAL * 5 / 607 ) / 1000
WGLOOP0:   	ldi  r17, $C9
WGLOOP1:   	dec  r17
           	brne WGLOOP1
           	dec  r16
           	brne WGLOOP0
			pop  r17
			pop  r16
           	ret                          ; wieder zurck


 ; Sendet den Befehl zur Lschung des Displays
lcd_clear:
           push  r16
           ldi   r16,0b00000001  		 ; Display lschen
           rcall lcd_command
           rcall delay5ms
           pop   r16
           ret

 ; Cursor Home
lcd_home:
           push  r16
           ldi   r16,    0b00000010   	; Cursor Home
           rcall lcd_command	
           rcall delay5ms
           pop   r16
           ret
	

 ; Initialisierung: muss ganz am Anfang des Programms aufgerufen werden
lcd_init:
           push  r16
		   push	 r17
		   push  r18
           ldi   r18,6
powerupwait:
           rcall delay5ms
           dec   r18
           brne  powerupwait
           ldi   r16,      0b00110000   ; muss 3mal hintereinander gesendet
           out   LCD_PORT, r16          ; werden zur Initialisierung
           rcall lcd_enable             ; 1
           rcall delay5ms
           rcall lcd_enable             ; 2
           rcall delay5ms
           rcall lcd_enable             ; und 3!
           rcall delay5ms

           ldi   r16,      0b00111000   ; 4 Bot, 2 Zeilen
           rcall lcd_command
           ldi   r16,      0b00001111   ; Display on, Cursor off
           rcall lcd_command
           ldi   r16,      0b00000100   ; endlich fertig
           rcall lcd_command

           pop   r18
		   pop	 r17
		   pop	 r16
           ret


lcd_data:

		   push  r17
           push  r18

           sbi   LCD_CTRL_PORT, PIN_RS

           out   LCD_PORT, r16           ; ausgeben
           rcall lcd_enable              ; Enable-Routine aufrufen
                                         ; 2. Nibble, kein swap da es schon
                                         ; Enable-Routine aufrufen
           rcall delay50us               ; Delay-Routine aufrufen

           pop   r18
           pop   r17
           ret                           ; zurck zum Hauptprogramm


lcd_command:

		   push  r17
           push  r18

           cbi   LCD_CTRL_PORT, PIN_RS

           out   LCD_PORT, r16           ; ausgeben
           rcall lcd_enable              ; Enable-Routine aufrufen
                                         ; 2. Nibble, kein swap da es schon
                                         ; Enable-Routine aufrufen
           rcall delay50us               ; Delay-Routine aufrufen

           pop   r18
           pop   r17
           ret                           ; zurck zum Hauptprogramm


lcd_flash_string:
           push  r16

lcd_flash_string_1:
           lpm   r16, Z+
           cpi   r16, 0
           breq  lcd_flash_string_2
           call  lcd_data
           rjmp  lcd_flash_string_1

lcd_flash_string_2:
           pop   r16
           ret
		   .EXIT
